import fs from 'node:fs/promises'

export const wgsl = ({ filterWith, filterExtension }) => ({
  name: 'esbuild-plugin-wgsl',
  setup(build) {
    const filter = filterExtension || true ? /\.wgsl$/ : /.*/
    build.onLoad({ filter }, async args => {
      if (!filterWith || args.filter.with === 'wgsl') {
        const contents = await fs.readFile(args.path, 'utf8')

        return { contents, loader: 'text' }
      }
    })
  }
})

export default wgsl

